#!/usr/bin/perl -w

use strict;

my %hash;
open my $file, 'autok.txt';
my %kms;
my %states;
my $maxkm=0;
my $count =0;
my %jour;
while (my $line = <$file>) {
	$count++;
	$line =~ s/\r//g;
	chomp $line;
	my @list = split / /, $line;
	$jour{$list[2]}{$list[3]}{'out'} = $list[4] if (not $list[5]);
	$jour{$list[2]}{$list[3]}{'max'} =0 if (not defined $jour{$list[2]}{$list[3]}{'max'});
	if ($list[5]) {
		$jour{$list[2]}{$list[3]}{'in'} = $list[4];
		$jour{$list[2]}{$list[3]}{'max'} = $jour{$list[2]}{$list[3]}{'in'}-$jour{$list[2]}{$list[3]}{'out'} if ($jour{$list[2]}{$list[3]}{'max'} < $jour{$list[2]}{$list[3]}{'in'}-$jour{$list[2]}{$list[3]}{'out'});
	}
	$hash{$count}{'nap'}=$list[0];
	$hash{$count}{'ido'}=$list[1];
	$hash{$count}{'rendsz'}=$list[2];
	$hash{$count}{'szaz'}=$list[3];
        $hash{$count}{'km'}=$list[4];
        $hash{$count}{'act'}=$list[5];
	$kms{$list[2]}{'min'}='99999999' if (not defined $kms{$list[2]}{'min'});
	$kms{$list[2]}{'max'}='0' if (not defined $kms{$list[2]}{'max'});
	$kms{$list[2]}{'min'}=$list[4] if ($list[4] < $kms{$list[2]}{'min'});
	$kms{$list[2]}{'max'}=$list[4] if ($list[4] > $kms{$list[2]}{'max'});
	$states{$list[2]}=$list[5];
	#print "max: $kms{$list[2]}{'max'}\nl4:$list[4]\nc:$count\n";
}

my @keys = sort {$a <=> $b} (keys %hash);
my $last=0;
foreach (reverse @keys) {
	next if $hash{$_}{'act'}==1;
	$last = $_;
	last;
}
print "2. feladat\n$hash{$last}{'nap'}. nap rendszam: $hash{$last}{'rendsz'}\n3. feladat\n";
print "Nap: ";
chomp (my $nap = <STDIN>);
print "Forgalom a(z) $nap. napon:\n";

foreach (@keys) {
	if ($nap == $hash{$_}{'nap'}) {
		print "$hash{$_}{'ido'} $hash{$_}{'rendsz'} $hash{$_}{'szaz'} ";
		print "be\n" if $hash{$_}{'act'}==1;
		print "ki\n" if $hash{$_}{'act'}!=1;
	}

}
print "4. feladat\n";
my $out=0;
foreach (keys %states) {
	$out++ if ($states{$_}==0);
}
print "A honap vegen $out autot nem hoztak vissza.\n5. feladat\n";

foreach (sort keys %kms) {
	my $dist=$kms{$_}{'max'}-$kms{$_}{'min'};
	print "$_ $dist\n";
}
print "6. feladat\n";
my $max=0;
my $mp;
foreach (keys %jour) {
	foreach my $k (keys $jour{$_}) {
		$mp = $k  if $max < $jour{$_}{$k}{'max'};
		$max = $jour{$_}{$k}{'max'} if $max < $jour{$_}{$k}{'max'};
	}
}
print "Leghosszabb ut: $max, szemely: $mp\n7. feladat\nRendszam: ";
chomp (my $rendsz= <STDIN>);
my $of = $rendsz.'_menetlevel.txt';
open my $outf, '>', "$of";
foreach (@keys) {
	if ($hash{$_}{'rendsz'} eq $rendsz) {
		if (not $hash{$_}{'act'}) {
			print $outf "$hash{$_}{'szaz'}\t$hash{$_}{'nap'}. $hash{$_}{'ido'}\t$hash{$_}{'km'} km\t";
		}
		else {
			print $outf "$hash{$_}{'nap'}. $hash{$_}{'ido'}\t$hash{$_}{'km'} km\n";
		}
	}
}
print "Menetlevel kesz.\n";
